GermanAnalyzer (Lucene 3.6.2 API)
Keywords: org.apache.lucene.analysis.de.GermanAnalyzer class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.analysis.de
Class GermanAnalyzer

    java.lang.Object
      org.apache.lucene.analysis.Analyzer
          org.apache.lucene.analysis.ReusableAnalyzerBase
              org.apache.lucene.analysis.StopwordAnalyzerBase
                  org.apache.lucene.analysis.de.GermanAnalyzer

All Implemented Interfaces:
  Closeable

    public final class GermanAnalyzer

extends org.apache.lucene.analysis.StopwordAnalyzerBase

`Analyzer` for German language.

Supports an external list of stopwords (words that will not be indexed at all) and an external list of exclusions (word that will not be stemmed, but indexed). A default set of stopwords is used unless an alternative list is specified, but the exclusion list is empty by default.

You must specify the required `Version` compatibility when creating GermanAnalyzer:

- As of 3.6, GermanLightStemFilter is used for less aggressive stemming.
- As of 3.1, Snowball stemming is done with SnowballFilter, and Snowball stopwords are used by default.
- As of 2.9, StopFilter preserves position increments

NOTE: This class uses the same `Version` dependent settings as `StandardAnalyzer`.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.analysis.ReusableAnalyzerBase
`org.apache.lucene.analysis.ReusableAnalyzerBase.TokenStreamComponents`

Field Summary
`static String` | `DEFAULT_STOPWORD_FILE` File containing default German stopwords.
`static String[]` | `GERMAN_STOP_WORDS` Deprecated. use `getDefaultStopSet()` instead

Fields inherited from class org.apache.lucene.analysis.StopwordAnalyzerBase
`matchVersion, stopwords`

Constructor Summary
`GermanAnalyzer(org.apache.lucene.util.Version matchVersion)` Builds an analyzer with the default stop words: `getDefaultStopSet()`.
`GermanAnalyzer(org.apache.lucene.util.Version matchVersion, File stopwords)` Deprecated. use `GermanAnalyzer(Version, Set)`
`GermanAnalyzer(org.apache.lucene.util.Version matchVersion, Map<?,?> stopwords)` Deprecated. use `GermanAnalyzer(Version, Set)`
`GermanAnalyzer(org.apache.lucene.util.Version matchVersion, Set<?> stopwords)` Builds an analyzer with the given stop words
`GermanAnalyzer(org.apache.lucene.util.Version matchVersion, Set<?> stopwords, Set<?> stemExclusionSet)` Builds an analyzer with the given stop words
`GermanAnalyzer(org.apache.lucene.util.Version matchVersion, String... stopwords)` Deprecated. use `GermanAnalyzer(Version, Set)`

Method Summary
`protected org.apache.lucene.analysis.ReusableAnalyzerBase.TokenStreamComponents` | `createComponents(String fieldName, Reader reader)` Creates `ReusableAnalyzerBase.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.
`static Set<?>` | `getDefaultStopSet()` Returns a set of default German-stopwords
`void` | `setStemExclusionTable(File exclusionlist)` Deprecated. use `GermanAnalyzer(Version, Set, Set)` instead
`void` | `setStemExclusionTable(Map<?,?> exclusionlist)` Deprecated. use `GermanAnalyzer(Version, Set, Set)` instead
`void` | `setStemExclusionTable(String[] exclusionlist)` Deprecated. use `GermanAnalyzer(Version, Set, Set)` instead

Methods inherited from class org.apache.lucene.analysis.StopwordAnalyzerBase
`getStopwordSet, loadStopwordSet, loadStopwordSet, loadStopwordSet`

Methods inherited from class org.apache.lucene.analysis.ReusableAnalyzerBase
`initReader, reusableTokenStream, tokenStream`

Methods inherited from class org.apache.lucene.analysis.Analyzer
`close, getOffsetGap, getPositionIncrementGap, getPreviousTokenStream, setPreviousTokenStream`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### GERMAN_STOP_WORDS

    @Deprecated
    public static final String[] GERMAN_STOP_WORDS

  Deprecated. use `getDefaultStopSet()` instead
  List of typical german stopwords.

### DEFAULT_STOPWORD_FILE

    public static final String DEFAULT_STOPWORD_FILE

  File containing default German stopwords.

  See Also:
    Constant Field Values

Constructor Detail

### GermanAnalyzer

    public GermanAnalyzer(org.apache.lucene.util.Version matchVersion)

  Builds an analyzer with the default stop words: `getDefaultStopSet()`.

### GermanAnalyzer

    public GermanAnalyzer(org.apache.lucene.util.Version matchVersion,
                          Set<?> stopwords)

  Builds an analyzer with the given stop words

  Parameters:
    `matchVersion` - lucene compatibility version
    `stopwords` - a stopword set

### GermanAnalyzer

    public GermanAnalyzer(org.apache.lucene.util.Version matchVersion,
                          Set<?> stopwords,
                          Set<?> stemExclusionSet)

  Builds an analyzer with the given stop words

  Parameters:
    `matchVersion` - lucene compatibility version
    `stopwords` - a stopword set
    `stemExclusionSet` - a stemming exclusion set

### GermanAnalyzer

    @Deprecated
    public GermanAnalyzer(org.apache.lucene.util.Version matchVersion,
                                     String... stopwords)

  Deprecated. use `GermanAnalyzer(Version, Set)`

  Builds an analyzer with the given stop words.

### GermanAnalyzer

    @Deprecated
    public GermanAnalyzer(org.apache.lucene.util.Version matchVersion,
                                     Map<?,?> stopwords)

  Deprecated. use `GermanAnalyzer(Version, Set)`

  Builds an analyzer with the given stop words.

### GermanAnalyzer

    @Deprecated
    public GermanAnalyzer(org.apache.lucene.util.Version matchVersion,
                                     File stopwords)
                   throws IOException

  Deprecated. use `GermanAnalyzer(Version, Set)`

  Builds an analyzer with the given stop words.

  Throws:
    `IOException`

Method Detail

### getDefaultStopSet

    public static final Set<?> getDefaultStopSet()

  Returns a set of default German-stopwords

  Returns:
    a set of default German-stopwords

### setStemExclusionTable

    @Deprecated
    public void setStemExclusionTable(String[] exclusionlist)

  Deprecated. use `GermanAnalyzer(Version, Set, Set)` instead

  Builds an exclusionlist from an array of Strings.

### setStemExclusionTable

    @Deprecated
    public void setStemExclusionTable(Map<?,?> exclusionlist)

  Deprecated. use `GermanAnalyzer(Version, Set, Set)` instead

  Builds an exclusionlist from a `Map`

### setStemExclusionTable

    @Deprecated
    public void setStemExclusionTable(File exclusionlist)
                               throws IOException

  Deprecated. use `GermanAnalyzer(Version, Set, Set)` instead

  Builds an exclusionlist from the words contained in the given file.

  Throws:
    `IOException`

### createComponents

    protected org.apache.lucene.analysis.ReusableAnalyzerBase.TokenStreamComponents createComponents(String fieldName,
                                                                                                     Reader reader)

  Creates `ReusableAnalyzerBase.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.

  Specified by:
    `createComponents` in class `org.apache.lucene.analysis.ReusableAnalyzerBase`
  Returns:
    `ReusableAnalyzerBase.TokenStreamComponents` built from a `StandardTokenizer` filtered with `StandardFilter`, `LowerCaseFilter`, `StopFilter` , `KeywordMarkerFilter` if a stem exclusion set is provided, `GermanNormalizationFilter` and `GermanLightStemFilter`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD